diff -ruN freeswan-1.9.orig/pluto/demux.c freeswan-1.9/pluto/demux.c
--- freeswan-1.9.orig/pluto/demux.c	Wed Jan 24 18:09:33 2001
+++ freeswan-1.9/pluto/demux.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: demux.c,v 1.95 2001/01/24 23:09:33 dhr Exp $
+ * RCSID $Id: demux.c,v 1.103 2001/05/05 02:51:37 dhr Exp $
  */
 
 /* Ordering Constraints on Payloads
@@ -139,6 +139,10 @@
 #include "whack.h"	/* requires connections.h */
 #include "server.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#endif
+
 /* This file does basic header checking and demux of
  * incoming packets.
  */
@@ -190,7 +194,7 @@
 
 /* state_microcode_table is a table of all state_microcode tuples.
  * It must be in order of state (the first element).
- * After initialization, state_microcode_index[s] points to the
+ * After initialization, ike_microcode_index[s] points to the
  * first entry in state_microcode_table for state s.
  * Remember that each state name in Main or Quick Mode describes
  * what has happened in the past, not what this message is.
@@ -241,11 +245,19 @@
 
     { STATE_MAIN_R1, SMF_PKE_AUTH
     , P(KE) | P(ID) | P(NONCE), P(VID) | P(HASH), PT(KE)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inI2_outR2_pk },
+#endif
 
     { STATE_MAIN_R1, SMF_RPKE_AUTH
     , P(NONCE) | P(KE) | P(ID), P(VID) | P(HASH) | P(CERT), PT(NONCE)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inI2_outR2_rpk },
+#endif
 
     /* for states from here on, output message must be encrypted */
 
@@ -263,11 +275,20 @@
 
     { STATE_MAIN_I2, SMF_PKE_AUTH | SMF_INITIATOR | SMF_OUTPUT_ENCRYPTED
     , P(KE) | P(ID) | P(NONCE), P(VID), PT(HASH)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inR2_outI3_pk /* ??? not yet implemented */ },
+#endif
 
-    { STATE_MAIN_I2, SMF_ALL_AUTH | SMF_INITIATOR | SMF_OUTPUT_ENCRYPTED
-    ,  P(NONCE) | P(KE) | P(ID), P(VID), PT(HASH)
+    { STATE_MAIN_I2, SMF_RPKE_AUTH | SMF_INITIATOR | SMF_OUTPUT_ENCRYPTED
+/*   ,  P(NONCE) | P(KE) | P(ID), P(VID), PT(HASH) */
+    ,  P(NONCE) | P(KE) | P(ID), P(VID) | P(CERT), PT(HASH)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inR2_outI3_rpk /* ??? not yet implemented */ },
+#endif
 
     /* for states from here on, input message must be encrypted */
 
@@ -282,11 +303,19 @@
 
     { STATE_MAIN_R2, SMF_DS_AUTH | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(ID) | P(SIG), P(VID) | P(CERT), PT(ID)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, main_inI3_outR3 },
+#else
+    , EVENT_SA_REPLACE, main_inI3_outR3_whichds},
+#endif
 
     { STATE_MAIN_R2, SMF_PKE_AUTH | SMF_RPKE_AUTH | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(HASH), P(VID), PT(HASH)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_SA_REPLACE, main_inI3_outR3_pk},
+#endif
 
     /* STATE_MAIN_I3: R3 --> done
      * SMF_PSK_AUTH: HDR*, IDr1, HASH_R --> done
@@ -300,11 +329,20 @@
 
     { STATE_MAIN_I3, SMF_DS_AUTH | SMF_INITIATOR | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(ID) | P(SIG), P(VID) | P(CERT), PT(NONE)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, main_inR3 },
+#else
+    , EVENT_SA_REPLACE, main_inR3_whichds },
+#endif
 
     { STATE_MAIN_I3, SMF_PKE_AUTH | SMF_RPKE_AUTH | SMF_INITIATOR | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(HASH), P(VID), PT(NONE)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_SA_REPLACE, main_inR3_pk },
+#endif
+
 
     /* STATE_MAIN_R3: can only get here due to packet loss */
     { STATE_MAIN_R3, SMF_ALL_AUTH | SMF_ENCRYPTED | SMF_RETRANSMIT_ON_DUPLICATE, LEMPTY, LEMPTY
@@ -749,7 +787,7 @@
 		}
 
 	    }
-#endif /* defined(IP_RECVERR) && defined(MSG_ERRQUEUE) */ 
+#endif /* defined(IP_RECVERR) && defined(MSG_ERRQUEUE) */
 	    return;
 	}
 	else if (from_ugh != NULL)
@@ -1241,6 +1279,8 @@
 	    {
 		lset_t s = LELEM(np);
 
+                loglog(RC_LOG_SERIOUS, "parsing: (%s)", 
+                   enum_show(&payload_names, np));
 		if (0 == (s & (needed | smc->opt_payloads
 		| LELEM(ISAKMP_NEXT_N) | LELEM(ISAKMP_NEXT_D))))
 		{
@@ -1253,6 +1293,267 @@
 		needed &= ~s;
 	    }
 
+#ifdef OPENSSL
+            {
+              /* This code really shouldn't be here - it should be in */
+              /* the ipsec_doi code section with all the other protocol */
+              /* spec. Unfortunately, the "syntax checking" of the payload */
+              /* is done here, and the "semantic checking" of the payload */
+              /* is over in ipsec_doi. Since the fields of the ID payload */
+              /* are encrypted, and the ipsec_doi code checks those fields */
+              /* before processing the ID payload, we must ensure that the */
+              /* payload is decrypted and stored in the identification */
+              /* structure *before* the main mode routines process it. So */
+              /* the code is here. */
+ 
+              if ((IS_PHASE1(md.from_state)) && (md.st)) {
+                if ((md.st->st_oakley.auth == OAKLEY_RSA_ENC) || 
+                    (md.st->st_oakley.auth == OAKLEY_ELGAMAL_ENC)) {
+                  if ((sd == &isakmp_identification_desc) ||
+                      (sd == &isakmp_nonce_desc)) {
+                    /* We need to decrypt this packet */
+                    char cpl[65], ppl[65];
+                    u_int16_t paylen;
+                    chunk_t ch;
+ 
+                    /* see macro in defs.h */
+                    readmem_u_int16_t(md.message_pbs.cur, 2, paylen);
+
+                    clonetochunk(ch, &(md.message_pbs.cur[4]), paylen-4, 
+                      "Ciphertext payload");
+ 
+                    /* Make a copy chunk of the payload after the generic */
+                    /* header, which should be the ciphertext of */
+                    /* the ID payload */
+                    if (sd == &isakmp_identification_desc) {
+                      snprintf(cpl, sizeof(cpl)-1, "ID payload (ciphertext): ");
+                      snprintf(ppl, sizeof(ppl)-1, "ID payload (plaintext): ");
+                    } else if (sd == &isakmp_nonce_desc) {
+                      snprintf(cpl, sizeof(cpl)-1,
+                               "Nonce payload (ciphertext): ");
+                      snprintf(ppl, sizeof(ppl)-1,
+                               "Nonce payload (plaintext): ");
+                    } else {
+                      snprintf(cpl, sizeof(cpl)-1,
+                               "Unknown payload (ciphertext): ");
+                      snprintf(ppl, sizeof(ppl)-1,
+                               "Unknown payload (plaintext): ");
+                    }
+ 
+                    if (!valid_ciphertext_length(paylen - 4, md.st->st_connection)) {
+                      log("Ciphertext length not a multiple of key modulus length for %s", cpl );
+                      free_md(&md);
+                      return;
+                    }
+
+                    DBG(DBG_RAW,
+                    DBG_dump_chunk(cpl, ch);
+                    );
+
+                    if (! privkey_decrypt_chunk( &ch, md.st )) {
+                      log("Ciphertext for %s could not be decrypted.", cpl );
+                      free_md(&md);
+                      return;
+                    }
+
+                    if ((ch.len == 0) || (ch.len > paylen)) {
+                      /* Error - the decryption has failed */
+                      log("Decryption failure - malformed payload in packet");
+                      free_md(&md);
+                      return;
+                    }
+
+                    DBG(DBG_RAW,
+                    DBG_dump_chunk(ppl, ch);
+                    );
+
+/*  ** a nice data dumper **
+ * {
+ * 	int *ptr = (int *) md.message_pbs.cur;
+ * 	int length = md.message_pbs.roof -  md.message_pbs.cur;
+ * 	int i;
+ * 	DBG_log("before memcopy: ---------------------- length %d", length);
+ * 	for (i=0; i<length/4; i+=4) {
+ * 		DBG_log("%4d: %08x %08x %08x %08x ", i*4, ntohl(ptr[0]), 
+ * 			ntohl(ptr[1]), ntohl(ptr[2]), ntohl(ptr[3]));
+ * 		ptr += 4;
+ * 	}
+ * }
+ */
+
+                    /* Now restructure the message_pbs block, so that the */ 
+                    /* plaintext is now stored in the ID/nonce payload space */
+                    /* Adjust the length first */
+                    /* see macro in defs.h */
+                    writemem_u_int16_t(md.message_pbs.cur, 2, (ch.len + 4));
+
+                    /* Now copy the plaintext */
+                    memcpy(&(md.message_pbs.cur[4]), ch.ptr, ch.len);
+                    /* Clear the source plaintext */
+                    memset(ch.ptr, 0, ch.len);
+
+                    /* Shift down all subsequent payloads */
+                    memmove(&(md.message_pbs.cur[ch.len+4]),
+                            &(md.message_pbs.cur[paylen]),
+                            md.message_pbs.roof - &(md.message_pbs.cur[paylen]));
+
+                    /* Adjust the size of root downwards */
+                    md.message_pbs.roof -= paylen - ch.len - 4;
+                    freeanychunk(ch);
+
+                  }
+                } else if ((md.st->st_oakley.auth == OAKLEY_RSA_ENC_REV) ||
+			   (md.st->st_oakley.auth == OAKLEY_ELGAMAL_ENC_REV)) {
+                  if ((sd == &isakmp_identification_desc) ||
+                      (sd == &isakmp_nonce_desc) ||
+                      (sd == &isakmp_keyex_desc) ||
+                      (sd == &isakmp_ipsec_certificate_desc)) {
+                    if (sd == &isakmp_nonce_desc) {
+                      /* Nonce is public key encrypted */
+                      u_int16_t paylen;
+                      chunk_t ch;
+ 
+                      /* see macro in defs.h */
+                      readmem_u_int16_t(md.message_pbs.cur, 2, paylen);
+
+                      clonetochunk(ch, &(md.message_pbs.cur[4]), paylen-4, 
+                        "Ciphertext payload");
+
+                      if (!valid_ciphertext_length(paylen - 4, 
+                        md.st->st_connection)) {
+                        log("Ciphertext length not a multiple of key modulus length for nonce" );
+                        free_md(&md);
+                        return;
+                      }
+
+                      DBG(DBG_PARSING | DBG_CRYPT, 
+                      DBG_dump_chunk("Nonce payload (ciphertext)", ch);
+                      );
+
+                      if (! privkey_decrypt_chunk( &ch, md.st )) {
+                        log("Ciphertext for %s could not be decrypted.",
+                          "Nonce payload (ciphertext)");
+                        free_md(&md);
+                        return;
+                      }
+
+                      if ((ch.len == 0) || (ch.len > paylen)) {
+                        /* Error - the decryption has failed */
+                        log("Decryption failure - malformed payload in packet");
+                        free_md(&md);
+                        return;
+                      }
+                      DBG(DBG_PARSING | DBG_CRYPT, 
+                      DBG_dump_chunk("Nonce payload (plaintext)", ch);
+                      );
+
+		      if ((md.st->st_state == STATE_MAIN_I1) ||
+			  (md.st->st_state == STATE_MAIN_I2) ||
+			  (md.st->st_state == STATE_MAIN_I3) ||
+			  (md.st->st_state == STATE_MAIN_I4)) {
+			if (derive_symmetric_key(md.st, ch,
+						 md.st->st_rcookie,
+						 COOKIE_SIZE,
+						 &md.st->st_ks_r,
+						 &md.st->st_ne_r) < 0) {
+			  log("Unable to derive symmetric key");
+			  free(&md);
+			  return;
+			}
+			memset(&md.st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+			DBG(DBG_PARSING,
+			DBG_dump_chunk("Received Ke_r:", md.st->st_ne_r);
+			);
+		      } else {
+			if (derive_symmetric_key(md.st, ch,
+						 md.st->st_icookie,
+						 COOKIE_SIZE,
+						 &md.st->st_ks_i,
+						 &md.st->st_ne_i) < 0) {
+			  log("Unable to derive symmetric key");
+			  free(&md);
+			  return;
+			}
+			memset(&md.st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+			DBG(DBG_PARSING,
+			DBG_dump_chunk("Received Ke_i:", md.st->st_ne_i);
+			);
+		      }
+
+                      /* Now restructure the message_pbs block, so that the */
+                      /* plaintext is now stored in the payload space */
+                      /* Adjust the length first */
+                      /* see macro in defs.h */ 
+                      writemem_u_int16_t(md.message_pbs.cur, 2, (ch.len + 4));
+
+                      /* Now copy the plaintext */
+                      memcpy(&(md.message_pbs.cur[4]), ch.ptr, ch.len);
+                      /* Clear the source plaintext */
+                      memset(ch.ptr, 0, ch.len);
+                      /* Shift down all subsequent payloads */
+                      memmove(&(md.message_pbs.cur[ch.len+4]),
+                              &(md.message_pbs.cur[paylen]),
+                              md.message_pbs.roof - &(md.message_pbs.cur[paylen]));
+		      /* Adjust the size of roof downwards */
+                      md.message_pbs.roof -= paylen - ch.len - 4;
+
+		      /* Discard the plaintext chunk */
+		      memset(ch.ptr, 0, ch.len);
+		      freeanychunk(ch);
+		    } else {
+                      u_int16_t paylen;
+                      chunk_t ch, pch;
+ 
+                      /* see macro in defs.h */
+                      readmem_u_int16_t(md.message_pbs.cur, 2, paylen);
+
+                      DBG(DBG_CRYPT, 
+		      DBG_log("Encrypted payload length = %d", paylen);
+                      );
+                      clonetochunk(ch, &(md.message_pbs.cur[4]), paylen-4, "Ciphertext payload");
+		      setchunk(pch, NULL, 0);
+		      if ((md.st->st_state == STATE_MAIN_I1) ||
+			  (md.st->st_state == STATE_MAIN_I2) ||
+			  (md.st->st_state == STATE_MAIN_I3) ||
+			  (md.st->st_state == STATE_MAIN_I4)) {
+			if (! decrypt_payload(md.st, &md.st->st_ks_r,
+					      md.st->st_ne_r_iv,
+					      ch, &pch) ) {
+			  log("Unable to decrypt responder payload");
+			  free(&md);
+			  return;
+			}
+		      } else {
+			if (!decrypt_payload(md.st, &md.st->st_ks_i,
+					     md.st->st_ne_i_iv,
+					     ch, &pch) ) {
+			  log("Unable to decrypt initiator payload");
+			  free(&md);
+			  return;
+			}
+		      }
+                      /* see macro in defs.h */ 
+                      writemem_u_int16_t(md.message_pbs.cur, 2, (pch.len + 4));
+
+                      /* Now copy the plaintext */
+                      memcpy(&(md.message_pbs.cur[4]), pch.ptr, pch.len);
+                      /* Shift down all subsequent payloads */
+                      memmove(&(md.message_pbs.cur[pch.len+4]),
+                              &(md.message_pbs.cur[paylen]),
+                              md.message_pbs.roof - &(md.message_pbs.cur[paylen]));
+		      /* Adjust the size of roof downwards */
+                      md.message_pbs.roof -= paylen - pch.len - 4;
+
+		      freeanychunk(ch);
+		      memset(pch.ptr, 0, pch.len);
+		      freeanychunk(pch);
+		    }
+		  } /* Otherwise, let everything else pass */
+		} /* end if (revised PK mode ) */
+	      } /* end if Phase 1 */
+	    } /* end OPENSSL handling */
+#endif /* OPENSSL */
+                                                                             
 	    if (!in_struct(&pd->payload, sd, &md.message_pbs, &pd->pbs))
 	    {
 		loglog(RC_LOG_SERIOUS, "%smalformed payload in packet", excuse);
@@ -1396,25 +1697,25 @@
 	{
 	    loglog(RC_LOG_SERIOUS, "ignoring informational payload, type %s"
 		, enum_show(&ipsec_notification_names, p->payload.notification.isan_type));
-	    DBG_cond_dump(DBG_PARSING, "info:", p->pbs.cur, pbs_left(&p->pbs));
+	    DBG_cond_dump(DBG_RAW, "info:", p->pbs.cur, pbs_left(&p->pbs));
 	}
 
 	for (p = md.chain[ISAKMP_NEXT_D]; p != NULL; p = p->next)
 	{
 	    loglog(RC_LOG_SERIOUS, "ignoring Delete SA payload");
-	    DBG_cond_dump(DBG_PARSING, "del:", p->pbs.cur, pbs_left(&p->pbs));
+	    DBG_cond_dump(DBG_RAW, "del:", p->pbs.cur, pbs_left(&p->pbs));
 	}
 
 	for (p = md.chain[ISAKMP_NEXT_VID]; p != NULL; p = p->next)
 	{
 	    loglog(RC_LOG_SERIOUS, "ignoring Vendor ID payload");
-	    DBG_cond_dump(DBG_PARSING, "VID:", p->pbs.cur, pbs_left(&p->pbs));
+	    DBG_cond_dump(DBG_RAW, "VID:", p->pbs.cur, pbs_left(&p->pbs));
 	}
 
 	for (p = md.chain[ISAKMP_NEXT_CERT]; p != NULL; p = p->next)
 	{
 	    loglog(RC_LOG_SERIOUS, "ignoring Certificate payload");
-	    DBG_cond_dump(DBG_PARSING, "CERT:", p->pbs.cur, pbs_left(&p->pbs));
+	    DBG_cond_dump(DBG_RAW, "CERT:", p->pbs.cur, pbs_left(&p->pbs));
 	}
     }
 
@@ -1598,13 +1899,13 @@
 
 		if (result == STF_UNPEND_QUICK && md.st->st_pending_quick)
 		{
-		    struct connection *c = md.st->st_connection;
+                   struct connection *c = md.st->st_connection;
 
-		    DBG(DBG_CONTROL, DBG_log("Doing Quick Mode with %s \"%s\""
-			, ip_str(&c->that.host_addr), c->name));
-		    (void) quick_outI1(dup_any(md.st->st_whack_sock)
-			, md.st, c, md.st->st_policy, 1);
-		    md.st->st_pending_quick = FALSE;
+                   DBG(DBG_CONTROL, DBG_log("Doing Quick Mode with %s \"%s\""
+                       , ip_str(&c->that.host_addr), c->name));
+                   (void) quick_outI1(dup_any(md.st->st_whack_sock)
+                       , md.st, c, md.st->st_policy, 1);
+                   md.st->st_pending_quick = FALSE;
 		}
 
 		if (IS_ISAKMP_SA_ESTABLISHED(md.st->st_state)
@@ -1635,9 +1936,9 @@
 		md.st = NULL;
 		break;
 
-	    case STF_DROP_DOOMED_EXCHANGE:
+	case STF_DROP_DOOMED_EXCHANGE:
 		loglog(RC_LOG_SERIOUS, "dropping exchange to avoid Pluto 1.0 bug"
-		    " handling DH shared secret with leading zero byte");
+		  " handling DH shared secret with leading zero byte");
 		delete_event(md.st);
 		delete_state(md.st);
 		md.st = NULL;
@@ -1666,3 +1967,306 @@
     }
     free_md(&md);
 }
+
+#ifdef OPENSSL
+int
+derive_symmetric_key( struct state *st, const chunk_t nonce,
+		      const u_char *seedptr, const size_t seedlen,
+		      keysched *ks,
+		      chunk_t *key )
+{
+  struct hmac_ctx ctx;
+  chunk_t k, kk, kchain;
+  chunk_t ne;
+  char nestr[8];
+  int needed_len;
+
+  DBG(DBG_PARSING, 
+	  DBG_dump_chunk("Deriving symmetric key from: ", nonce);
+	  DBG_dump("Initial Cookie:", seedptr, seedlen);
+	);
+  switch(st->st_oakley.encrypt) {
+#if 0
+    /* We really shouldn't deal with DES, */
+    /* uncomment this if you must have it */
+  case OAKLEY_DES_CBC:
+    needed_len = DES_CBC_BLOCK_SIZE;
+    break;
+#endif
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    needed_len = IDEA_CBC_KEY_LEN;
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    needed_len = BLOWFISH_CBC_KEY_LEN;
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    needed_len = RC5_CBC_KEY_LEN;
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    needed_len = DES_CBC_BLOCK_SIZE * 3;
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    needed_len = CAST_CBC_KEY_LEN;
+    break;
+#endif
+  default:
+    log("Unknown block cipher ID for symmetric cipher");
+    return -1;
+  }
+
+  /* Generate initial decryption key material */
+  /* key = prf(Nonce-X, Cookie-X); X={I,R} */
+  ne.ptr = NULL;
+  hmac_init_chunk(&ctx, st->st_oakley.hasher, nonce);
+  hmac_update(&ctx, seedptr, seedlen);
+  hmac_final_chunk(ne, nestr, &ctx);
+  clonetochunk(*key, ne.ptr, ne.len, "Initial key material");
+
+  if (key->len < needed_len) {
+    freeanychunk(*key);
+    kchain.ptr = alloc_bytes(1, "initial zero octet");
+    kchain.len = 1;
+    memset(kchain.ptr, 0, kchain.len);
+    while (key->len < needed_len) {
+      kk.ptr = NULL;
+      hmac_init_chunk(&ctx, st->st_oakley.hasher, ne);
+      hmac_update_chunk(&ctx, kchain);
+      hmac_final_chunk(kk, "extra key material", &ctx);
+      clonereplacechunk(kchain, kk.ptr, kk.len, "chain key material");
+      /* Now append kk to key */
+      if (! key->ptr ) {
+	clonetochunk(*key, kk.ptr, kk.len, "initial extra key material");
+      } else {
+	k.ptr = alloc_bytes(key->len + kk.len, "appended key material");
+	k.len = key->len + kk.len;
+	memcpy(k.ptr, key->ptr, key->len);
+	memcpy(&(k.ptr[key->len]), kk.ptr, kk.len);
+	freeanychunk(*key);
+	key->len = k.len;
+	key->ptr = k.ptr;
+      }
+      freeanychunk(kk);
+    }
+    freeanychunk(kchain);
+  }
+
+  switch(st->st_oakley.encrypt) {
+#if 0
+    /* We really shouldn't deal with DES, */
+    /* uncomment this if you must have it */
+  case OAKLEY_DES_CBC:
+    (void)des_set_key((des_cblock *)key->ptr, ks->des_ks);
+    break;
+#endif
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    (void)des_set_key((des_cblock *)key->ptr + 0, ks->des3_ks.ks[0]);
+    (void)des_set_key((des_cblock *)key->ptr + 1, ks->des3_ks.ks[1]);
+    (void)des_set_key((des_cblock *)key->ptr + 2, ks->des3_ks.ks[2]);
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  return 0;
+}
+
+bool
+encrypt_payload( struct state *st, keysched *ks, u_char *iv,
+		 chunk_t inp, chunk_t *out )
+{
+  chunk_t temp;
+  int blocklen;
+  u_char pv;
+
+  switch(st->st_oakley.encrypt) {
+#if 0
+  case OAKLEY_DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#endif
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  /* Pad the input up to a block size multiple */
+  if (inp.len % blocklen == 0) { /* Add a full block for padding */
+    pv = (u_char)blocklen;
+    temp.len = inp.len + (size_t)pv;
+  } else {
+    pv = (u_char)(blocklen - 1  - ((inp.len + blocklen - 1) % blocklen));
+    temp.len = inp.len + (size_t)pv;
+  }
+
+  temp.ptr = alloc_bytes(temp.len, "padded plaintext");
+  memset(temp.ptr, 0, temp.len);
+  clonetochunk(*out, temp.ptr, temp.len, "ciphertext");
+  memcpy(temp.ptr, inp.ptr, inp.len);
+  temp.ptr[temp.len-1] = pv;
+  
+  DBG(DBG_PARSING | DBG_CRYPT,
+	  DBG_dump_chunk("Plaintext:", temp);
+	  DBG_dump("Old IV: ", iv, blocklen);
+	);
+
+  switch(st->st_oakley.encrypt) {
+#if 0
+  case OAKLEY_DES_CBC:
+    des_ncbc_encrypt((des_cblock *)temp.ptr, (des_cblock *)out->ptr,
+		     temp.len, ks->des_ks, (des_cblock *)iv, TRUE);
+    break;
+#endif
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    des_ede3_cbc_encrypt((des_cblock *)temp.ptr, (des_cblock *)out->ptr,
+			 temp.len,
+			 ks->des3_ks.ks[0],
+			 ks->des3_ks.ks[1],
+			 ks->des3_ks.ks[2],
+			 (des_cblock *)iv, TRUE);
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  DBG(DBG_PARSING | DBG_CRYPT,
+	DBG_dump_chunk("Ciphertext: ", *out);
+	DBG_dump("New IV: ", iv, blocklen);
+	);
+  freeanychunk(temp);
+  return TRUE;
+}
+
+bool
+decrypt_payload( struct state *st, keysched *ks, u_char *iv,
+		 chunk_t inp, chunk_t *out )
+{
+  chunk_t temp;
+  int blocklen;
+
+  switch(st->st_oakley.encrypt) {
+#if 0
+  case OAKLEY_DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#endif
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  if (inp.len % blocklen != 0) {
+    log("Ciphertext is not a multiple of block length");
+    return FALSE;
+  }
+
+  DBG(DBG_PARSING | DBG_CRYPT,
+	DBG_dump_chunk("Ciphertext: ", inp);
+	DBG_dump("Old IV: ", iv, blocklen);
+	);
+
+  temp.ptr = alloc_bytes(inp.len, "temporary plaintext");
+  temp.len = inp.len;
+  memset(temp.ptr, 0, temp.len);
+
+  switch(st->st_oakley.encrypt) {
+#if 0
+  case OAKLEY_DES_CBC:
+    des_ncbc_encrypt((des_cblock *)inp.ptr, (des_cblock *)temp.ptr,
+		     inp.len, ks->des_ks, (des_cblock *)iv, FALSE);
+    break;
+#endif
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    des_ede3_cbc_encrypt((des_cblock *)inp.ptr, (des_cblock *)temp.ptr,
+			 inp.len,
+			 ks->des3_ks.ks[0],
+			 ks->des3_ks.ks[1],
+			 ks->des3_ks.ks[2],
+			 (des_cblock *)iv, FALSE);
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  /* Strip padding from plaintext */
+  if ((temp.ptr[temp.len-1] < (u_char)1) ||
+      (temp.ptr[temp.len-1] > (u_char)blocklen) ||
+      (temp.ptr[temp.len-1] > temp.len)) {
+    /* Impossible padding value */
+    log("Impossible plaintext padding value: %d", temp.ptr[temp.len-1]);
+    memset(temp.ptr, 0, temp.len);
+    freeanychunk(temp);
+    return FALSE;
+  }
+
+  out->len = temp.len - (size_t)(temp.ptr[temp.len-1]);
+  out->ptr = alloc_bytes(inp.len, "plaintext");
+  memcpy(out->ptr, temp.ptr, out->len);
+
+  DBG(DBG_PARSING | DBG_CRYPT,
+	DBG_dump_chunk("Plaintext: ", *out);
+	DBG_dump("New IV: ", iv, blocklen);
+	);
+
+  memset(temp.ptr, 0, temp.len);
+  freeanychunk(temp);
+  return TRUE;
+}
+
+#endif
diff -ruN freeswan-1.9.orig/pluto/demux.h freeswan-1.9/pluto/demux.h
--- freeswan-1.9.orig/pluto/demux.h	Tue Sep 12 02:59:26 2000
+++ freeswan-1.9/pluto/demux.h	Wed May 16 10:57:20 2001
@@ -77,3 +77,15 @@
 } stf_status;
 
 typedef stf_status state_transition_fn(struct msg_digest *md);
+
+#ifdef OPENSSL
+extern int derive_symmetric_key( struct state *st, const chunk_t nonce,
+				 const u_char *seedptr,
+				 const size_t seedlen,
+				 keysched *ks,
+				 chunk_t *key );
+extern bool encrypt_payload( struct state *st, keysched *ks, u_char *iv,
+			   chunk_t inp, chunk_t *out );
+extern bool decrypt_payload( struct state *st, keysched *ks, u_char *iv,
+			     chunk_t inp, chunk_t *out );
+#endif /* OPENSSL */
